
#include <windows.h>
#include <stdio.h>
#include "DbgPrnHk.h"
#include "DbgPrintLog.h"
#include "dbgprint_opt.h"
//#include "dbgprn_options.h"

#define pOpt     opt

int
DbgPrint_CmdLine_to_OptStruct(
    IN PWCHAR CmdLine,
    IN BOOLEAN Reinit,
    OUT PDBGDUMP_OPT opt_struct
    )
{
    int argc;
    WCHAR** argv;
    LONG i=0;
    LONG j;
    WCHAR a;
    PDBGDUMP_OPT_RAW opt = (PDBGDUMP_OPT_RAW)opt_struct;

    if(Reinit) {
        #define DBGPRINT_DRV_OPT_RAW_INIT
        #include "dbgprint_opt_list.h"
    }

    argv = CommandLineToArgvW(CmdLine, &argc);
    for(i=1; i<argc; i++) {
        if(!argv[i] || argv[i][0] != '-') {
            opt->LogFile = argv[i];
            continue;
        }
        if(!wcscmp(argv[i], L"-h") ||
           !wcscmp(argv[i], L"-?") ||
           !wcscmp(argv[i], L"//h") ||
           !wcscmp(argv[i], L"//?") ||
           !wcscmp(argv[i], L"--help")) {
//            usage();
//            exit(0);
            return 0;
        } else
        if(!wcscmp(argv[i], L"-sm")) {
            opt->sync_mode = TRUE;
        } else
        if(!wcscmp(argv[i], L"-wd")) {
            i++;
            if(i >= argc) {
                print_log("%s requires pathname\n", argv[i-1]);
                return -2;
            }
            if(opt->WDir) {
                GlobalFree(opt->WDir);
            }
            j = wcslen(argv[i])+1;
            opt->WDir = (PWCHAR)GlobalAlloc(GMEM_FIXED, j*sizeof(WCHAR));
            memcpy(opt->WDir, argv[i], j*sizeof(WCHAR));
            opt->WDir[j-1] = 0;
        } else
        if(!wcscmp(argv[i], L"-drvopt") ||
           !wcscmp(argv[i], L"--drvopt") ||
           !wcscmp(argv[i], L"--opt:drv")) {
            i++;
            if(i >= argc) {
                print_log("%s requires parameter\n", argv[i-1]);
                return -2;
            }
/*
            for(j=0; DbgPrintHook_Options[j].OptionName; j++) {
                if(!wcsicmp(argv[i], DbgPrintHook_Options[j].OptionName)) {
                    i++;
                    if(i >= argc) {
                        print_log("No value specified for driver option %s\n", argv[i-1]);
//                        usage();
//                        exit(-2);
                        return -2;
                    }
                    if(!wcscmp(argv[i], L"*")) {
                        DbgPrintHook_Options[j].Value.OptDword = DbgPrintHook_Options[j].DefValue.OptDword;
                    } else {
                        swscanf(argv[i], L"%d", &DbgPrintHook_Options[j].Value.OptDword);
                    }
                    DbgPrintHook_Options[j].UpdateFlag = TRUE;
                    break;
//                    if(DbgPrintHook_Options[j].OptionType != 0) {
//                    }
                }
            }
            if(!DbgPrintHook_Options[j].OptionName) {
                if(!wcscmp(argv[i], L"*")) {
                    // Use all defaults
                    for(j=0; DbgPrintHook_Options[j].OptionName; j++) {
                        DbgPrintHook_Options[j].Value.OptDword = DbgPrintHook_Options[j].DefValue.OptDword;
                        DbgPrintHook_Options[j].UpdateFlag = TRUE;
                    }
                } else {
                    print_log("Invalid driver option %s\n", argv[i]);
//                    usage();
//                    exit(-2);
                    return -2;
                }
            }
//            if(sys_account) {
//                continue;
//            }
*/

            // recognize driver options and fill structure
            #define DBGPRINT_DRV_OPT_RAW_RECOGNIZE
            #include "dbgprint_opt_list.h"
            /* else */
            if(!wcscmp(argv[i], L"*")) {
                // Use all defaults
                #define DBGPRINT_DRV_OPT_RAW_INIT_WITH_APPLY
                // reinit values
                #define DBGPRINT_DRV_OPT_RAW_INIT
                #include "dbgprint_opt_list.h"
            } else {
                print_log("Invalid driver option %s\n", argv[i]);
                return -2;
            }
            
            opt->drv_opt = TRUE;
        } else
        if(!wcscmp(argv[i], L"-drv")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"1")) {
                    opt->drv_mode = SERVICE_BOOT_START;
                    opt->drv_very_first = TRUE;
                } else
                if(!wcscmp(argv[i], L"B")) {
                    opt->drv_mode = SERVICE_BOOT_START;
                } else
                if(!wcscmp(argv[i], L"S")) {
                    opt->drv_mode = SERVICE_SYSTEM_START;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    opt->drv_mode = SERVICE_AUTO_START;
                } else
                if(!wcscmp(argv[i], L"M")) {
                    opt->drv_mode = SERVICE_DEMAND_START;
                } else
                if(!wcscmp(argv[i], L"U")) {
/*
                    if(sys_account) {
                        continue;
                    }
                    remove_driver();
*/
                    //opt->deinstall_drv = TRUE;
                    opt->drv_mode = SERVICE_DISABLED;
                    //continue;
                } else {
                    // revert to initial state
                    i--;
                }
            }
//            if(sys_account) {
//                continue;
//            }
            opt->install_drv = TRUE;
        } else
        if(!wcscmp(argv[i], L"-svc")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"U")) {
/*
                    if(sys_account) {
                        continue;
                    }
*/
/*
                    k = NtServiceStop(NT_DbgPrnHk_Client_SVC_NAME, 10);
                    k = NtServiceRemove(NT_DbgPrnHk_Client_SVC_NAME);
                    if(k == 1) {
                        print_log("DbgPrintLog service is uninstalled\n");
                    }
                    deinstall = TRUE;
                    continue;
*/
                    opt->svc_mode = SERVICE_DISABLED;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    opt->svc_mode = SERVICE_AUTO_START;
                } else
                if(!wcscmp(argv[i], L"M")) {
                    opt->svc_mode = SERVICE_DEMAND_START;
                } else {
                    // revert to initial state
                    i--;
                }
            }
/*
            if(sys_account) {
                continue;
            }
*/
            opt->install_svc = TRUE;
        } else
/*
        if(!wcscmp(argv[i], L"-run_mode")) {
            i++;
            if(i < argc) {
                if(!wcscmp(argv[i], L"S")) {
                    force_run_mode = TRUE;
                    run_mode_svc = TRUE;
                } else
                if(!wcscmp(argv[i], L"A")) {
                    force_run_mode = TRUE;
                    run_mode_svc = FALSE;
                } else
                {
                    return -2;
                }
            }
        } else
*/
        if(!wcscmp(argv[i], L"-no_drv") ||
           !wcscmp(argv[i], L"--no_drv")) {
            opt->without_driver = TRUE;
        } else
        if(!wcsicmp(argv[i], L"-s")) {
            if(argv[i][1] == 'S') {
                opt->prealloc_mode = TRUE;
            }
            i++;
            if(i >= argc) {
                print_log("%s requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->MaxLogSize);
            if(!opt->MaxLogSize || opt->MaxLogSize > 2047) {
                print_log("Invalid %s value: %s\n", argv[i-1], argv[i]);
                return -2;
            }
            opt->MaxLogSize = opt->MaxLogSize << 20;
        } else
        if(!wcscmp(argv[i], L"-x")) {
            opt->use_index = TRUE;
        } else
        if(!wcscmp(argv[i], L"-l")) {
            i++;
            if(i >= argc) {
                print_log("%s requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->MaxLogs);
        } else
        if(!wcscmp(argv[i], L"-n")) {
            i++;
            if(i >= argc) {
                print_log("%s requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->StartLogNum);
        } else
        if(!wcscmp(argv[i], L"-ft")) {
            i++;
            if(i >= argc) {
                print_log("%s requires parameter\n", argv[i-1]);
                return -2;
            }
            swscanf(argv[i], L"%d", &opt->FlushTimeout);
        } else
        if(!wcscmp(argv[i], L"-cf")) {
            opt->output_file = TRUE;
            opt->output_stdout = TRUE;
        } else
        if(!wcscmp(argv[i], L"--stdout") ||
           !wcscmp(argv[i], L"-o")) {
            opt->output_file = FALSE;
            opt->output_stdout = TRUE;
        } else
        if(!wcscmp(argv[i], L"--in_drv")) {
            opt->input_driver = TRUE;
            opt->input_file   = FALSE;
            opt->input_stdin  = FALSE;
        } else
        if(!wcscmp(argv[i], L"--stdin")) {
            opt->input_driver = FALSE;
            opt->input_file   = FALSE;
            opt->input_stdin  = TRUE;
            opt->without_driver = FALSE;
            opt->log_time_perf = TRUE;
        } else
        if(!wcscmp(argv[i], L"-in_file") ||
           !wcscmp(argv[i], L"--in_file")) {
            i++;
            if(i >= argc) {
                print_log("%s requires filename\n", argv[i-1]);
                return -1;
            }
            if(opt->input_FileName) {
                GlobalFree(opt->input_FileName);
            }
            j = wcslen(argv[i])+1;
            opt->input_FileName = (PWCHAR)GlobalAlloc(GMEM_FIXED, j*sizeof(WCHAR));
            memcpy(opt->input_FileName, argv[i], j*sizeof(WCHAR));
            opt->input_FileName[j-1] = 0;

            opt->input_driver = FALSE;
            opt->input_file   = TRUE;
            opt->input_stdin  = FALSE;
            opt->without_driver = FALSE;
            opt->log_time_perf = TRUE;
        } else

        #define ARG_OPT_UNICODE
        #include "fmt_output_opt.h"

        if(!wcscmp(argv[i], L"-rd")) {
            opt->restart_drv = TRUE;
/*
        } else
        if(!wcscmp(argv[i], L"-chcfg")) {
            change_config = TRUE;
*/

        } else {
            //print_log("Unrecognized option: %s\n", argv[i]);
            return 0;
        }
    }
    return 1;
} // end DbgPrint_CmdLine_to_OptStruct()

VOID
DbgPrint_Cleanup_OptStruct(
    OUT PDBGDUMP_OPT opt_struct
    )
{
    PDBGDUMP_OPT_RAW opt = (PDBGDUMP_OPT_RAW)opt_struct;

} // end DbgPrint_Cleanup_OptStruct()